<template>
    <v-card class="checkout-form-card my-xs-4"
            max-width="100%"
            min-height="550">
        <v-card-title class="checkout-form-card-title py-2 py-md-4 px-md-8 px-lg-8">
            Account Informations
        </v-card-title>
        <v-form
            ref="form"
            v-model="valid"
            class="pt-6"
            lazy-validation>
            <v-row>
                <v-col cols="12" class="px-8 px-md-10 px-lg-10">
                    <v-text-field
                        v-model="inputValue.name"
                        :rules="validation.nameRules"
                        label="Name*"
                        persistent-hint
                        clearable
                        outlined
                        required/>
                </v-col>
            </v-row>
            <v-row>
                <v-col cols="12" class="px-8 px-md-10 px-lg-10">
                    <v-text-field
                        v-model="inputValue.email"
                        type="email"
                        :rules="validation.emailRules"
                        label="E-mail address*"
                        clearable
                        persistent-hint
                        outlined/>
                </v-col>
            </v-row>
            <v-row class="hidden-xs-only social-contact">
                <v-col cols="5" class="pr-0 pl-sm-8 pl-md-10 pl-lg-10">
                    <v-select
                        v-model="inputValue.socialContact"
                        class="social-contact-selector"
                        :items="socialContactItems"
                        label="Social Contact"
                        clearable
                        persistent-hint
                        outlined/>
                </v-col>
                <v-col cols="7" class="pl-0 pr-sm-8 pr-md-10 pr-lg-10">
                    <v-text-field
                        v-model="inputValue.socialContactInfo"
                        class="social-contact-info"
                        clearable
                        persistent-hint
                        outlined/>
                </v-col>
            </v-row>
            <v-row class="hidden-sm-and-up">
                <v-col cols="12" class="px-8">
                    <v-select
                        v-model="inputValue.socialContact"
                        :items="socialContactItems"
                        label="Social Contact"
                        clearable
                        persistent-hint
                        outlined/>
                </v-col>
                <v-col v-show="inputValue.socialContact !== '' && inputValue.socialContact !== undefined"
                       cols="12"
                       class="px-8">
                    <v-text-field
                        v-model="inputValue.socialContactInfo"
                        clearable
                        persistent-hint
                        outlined/>
                </v-col>
            </v-row>
        </v-form>
        <v-row>
            <v-col cols="12">
                <v-card-text class="checkout-form-card-data-protected py-1 pl-4 pl-md-8 pl-lg-8">
                    <v-icon class="pr-2 benefit-check-icon">
                        mdi-check
                    </v-icon>
                    <span class="growth-benefit-allow">Your personal data will be protected</span>
                </v-card-text>
            </v-col>
        </v-row>
        <v-row>
            <v-col cols="12">
                <v-card-actions cols="12" class="pl-4 pl-md-8 pl-lg-8">
                    <v-btn
                        color="#FD1D1D"
                        dark
                        @click="submit">
                        Order Now!
                    </v-btn>
                </v-card-actions>
            </v-col>
        </v-row>
    </v-card>
</template>

<script>
import router from '../../../router'
import { mapActions, mapGetters } from 'vuex'

export default {
    name: 'CheckoutForm',
    data: () => ({
        validation: {
            nameRules: [
                v => !!v || 'Name is required'
            ],
            emailRules: [
                v => !!v || 'E-mail is required',
                v => /.+@.+/.test(v) || 'E-mail must be valid'
            ],
        },
        inputValue: {
            name: '',
            email: '',
            socialContact: '',
            socialContactInfo: '',
        },
        socialContactItems: [
            'facebook',
            'instagram',
            'whatsapp',
            'email',
            'phone'
        ],
        valid: true,
    }),
    computed: {
        ...mapGetters(['getPricePlanSelected', 'getClientInfoError']),
        getPricePlan () {
            return this.getPricePlanSelected
        },
        getError() {
            return this.getClientInfoError
        }
    },
    methods: {
        ...mapActions(['sendClientInfo', 'goToThankYouPage']),
        submit () {
            if (this.$refs.form.validate()) {
                this.snackbar = true
                let clientInfo = {
                    name: this.inputValue.name,
                    email: this.inputValue.email,
                    socialContact: this.inputValue.socialContact,
                    socialAccount: this.inputValue.socialContactInfo,
                    pricingPlan: this.getPricePlan
                }
                this.sendClientInfo(clientInfo).then(() => {
                    if(!this.getError.hasError) {
                        this.goToThankYouPage(true).then(() => {
                            router.push({ name: 'ThankYou' })
                            sessionStorage.clear()
                        })
                    }
                })
            }
        },
    }
}
</script>

<style lang="scss" scoped>
    .checkout-form-card {
        @media(max-width: 960px) {
            border: 2px solid #f0f0f0;
            box-shadow: none;
        }
        &-title {
            border-bottom: 1px solid #f0f0f0;
            @media(max-width: 960px) {
                background-color: #f0f0f0;
            }
        }
        &-data-protected {
            display: flex;
            border: 1px solid #f0f0f0;
            .benefit-check-icon {
                font-size: 16px;
            }
        }
        .social-contact {
            &-info {
                border-top-left-radius: 0;
                border-bottom-left-radius: 0
            }
            &-selector {
                border-top-right-radius: 0;
                border-bottom-right-radius: 0;
            }
        }
    }
</style>
